unit prolo_interface;

interface

{
  This file has been generated, if you wish to
  modify it in a permanent way, please refer
  to the script file : gen/generator_pascal.rb
}

const
{
  Un des arguments passe a la fonction est incorrect.
}
	BAD_ARGUMENT              =  -4;
{
  Vous ne pouvez pas appeler cette commande maintenant.
}
	INVALID_COMMAND           =  -3;
{
  L'unite demande n'existe pas (ou plus).
}
	NO_UNIT                   =  -2;
{
  Le resultat ne peut pas etre connu.
}
	UNKNOWN                   =  -1;
{
  La commande s'est correctement effectuee.
}
	SUCCESS                   =  0;
{
  Nombre maximum de tours.
}
	MAX_TURN                  =  500;
{
  Taille maximum de la carte en largeur/hauteur.
}
	MAX_MAP_SIZE              =  40;
{
  Nombre maximal d'equipes en jeu.
}
	MAX_TEAM                  =  6;
{
  Nombre maximal de leucocyte par equipe.
}
	MAX_WHITE_CELL            =  5;
{
  Nombre maximal de bacteries sur une case.
}
	MAX_BACTERY               =  20;
{
  Nombre maximal de nutriments sur une case.
}
	MAX_NUTRIENT              =  50;
{
  Nombre maximum de points de competence d'un leucocyte.
}
	MAX_SKILL                 =  12;
{
  Quantite de nutriments apportes par le sang  chaque tour.
}
	NEW_NUTRIENT              =  10;
{
  Quantite de nutriments qu'une cellule peut consommer par tour.
}
	CELL_NUTRIENT             =  10;
{
  Quantite de nutriments dont une cellule a besoin pour faire une mitose.
}
	CELL_MITOSIS_MATERIAL     =  50;
{
  Quantite de nutriments dont une cellule a besoin pour fabriquer un virus.
}
	VIRUS_MATERIAL            =  50;
{
  Quantite de nutriments qu'une bactrie peut consommer par tour.
}
	BACTERY_NUTRIENT          =  10;
{
  Nombre de tours ncessaires a une cellule pour produire un virus.
}
	VIRUS_PRODUCTION_DURATION =  10;
{
  Nombre de tours ncessaires a une cellule pour se diviser.
}
	MITOSIS_DURATION          =  50;
{
  Nombre de tours ncessaires a un virus pour transformer une cellule.
}
	INFECTION_DURATION        =  10;
{
  Nombre de tours ncessaires a un leucocyte pour digerer un virus.
}
	PHAGOCYTOSIS_DURATION     =  10;
{
  Rseau sanguin.
}
	VESSEL                    =  0;
{
  Tissu cellulaire.
}
	FLESH                     =  1;
{
  Un leucocyte se trouve a cet endroit.
}
	WHITE_CELL                =  2;
{
  Une cellule se trouve a cet endroit.
}
	CELL                      =  3;
{
  Une cellule se trouve a cet endroit.
}
	BACTERIA                  =  4;
{
  Un virus se trouve a cet endroit.
}
	VIRUS                     =  5;
{
  La cellule est saine.
}
	CELL_STATE_HEALTHY        =  0;
{
  La cellule est infecte par un virus.
}
	CELL_STATE_INFECTED       =  1;
{
  La cellule est morte.
}
	CELL_STATE_PRODUCTING_VIRII =  2;
{
  La cellule est morte.
}
	CELL_STATE_DEAD           =  3;
{
  Le globule blanc est disponible.
}
	STATE_NORMAL              =  0;
{
  Le leucocyte est en train de phagocyter.
}
	STATE_PHAGOCYTOSING       =  1;
{
  Le leucocyte est mort.
}
	STATE_DEAD                =  3;
{
  Deplacement vers le haut.
}
	DEC_Y                     =  0;
{
  Deplacement vers la gauche.
}
	DEC_X                     =  1;
{
  Deplacement vers le bas.
}
	INC_Y                     =  2;
{
  Deplacement vers la droite.
}
	INC_X                     =  3;
{
  Nombre d'equipes presentes sur le terrain.
}
function equipes() : LongInt; cdecl; external;

{
  Nombre de leucocytes dans l'equipe.
}
function taille_equipe(team_number : LongInt) : LongInt; cdecl; external;

{
  Identifiant de votre equipe.
}
function mon_equipe() : LongInt; cdecl; external;

{
  Identifiant de votre unite
}
function mon_identifiant() : LongInt; cdecl; external;

{
  Taille du monde en largeur.
}
function taille_corps_x() : LongInt; cdecl; external;

{
  Taille du monde en hauteur.
}
function taille_corps_y() : LongInt; cdecl; external;

{
  Recupere le type de terrain a la position demandee. Si aucun de vos
  joueurs ne peut voir la case en question (brouillard de guerre), la
  fonction ne renverra que VESSEL ou FLESH. Si vous pouvez la voir,
  alors la valeur de retour sera plus precise.

}
function regarde(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Dit si des bacteries sont presentes sur la case specifiee.

}
function bacteries_presentes(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Regarde si une case du terrain se trouve dans le champ de vision de vos
  joueurs.

}
function visible(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Recupere le score d'une equipe.
}
function score(id : LongInt) : LongInt; cdecl; external;

{
  Date actuelle.
}
function current_beat() : LongInt; cdecl; external;

{
  Temps restant pour ce tour.
}
function time_remaining() : LongInt; cdecl; external;

{
  Temps additionnel restant pour la partie.
}
function extra_time_remaining() : LongInt; cdecl; external;

{
  Le leucocyte est-il visible ?
}
function leucocyte_visible(id : LongInt) : LongInt; cdecl; external;

{
  Permet de savoir l'identifiant d'un leucocyte sur une case.

}
function identifiant_leucocyte(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Recupere l'identifiant d'equipe auquel appartient un leucocyte.
}
function equipe(id : LongInt) : LongInt; cdecl; external;

{
  Position d'un leucocyte en largeur.
}
function position_leucocyte_x(id : LongInt) : LongInt; cdecl; external;

{
  Position d'un leucocyte en hauteur.
}
function position_leucocyte_y(id : LongInt) : LongInt; cdecl; external;

{
  Recupere l'etat d'un leucocyte.
}
function etat_leucocyte(id : LongInt) : LongInt; cdecl; external;

{
  Recupere l'etat d'une cellule.
}
function etat_cellule(id : LongInt) : LongInt; cdecl; external;

{
  Sert a se renseigner si le joueur connait deja un type de signature d'un virus.

}
function connait_type(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Defini les competence d'un leucocyte

}
function defini_competence(rapidite : LongInt; anticorps : LongInt; messages : LongInt; vision : LongInt) : LongInt; cdecl; external;

{
  Deplace un de ses leucocyte \emph{vers} la position indiquee. Il ne se deplace que
  d'une seule case par tour.

}
function deplace_leucocyte(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Phagocytose de l'entite qui se trouve aux coordonnees indiques.
  S'il s'agit d'un virus dont le type n'est pas encore connu,
  l'appel a cette fonction immobilisera plus longtemps le leucocyte
  que si le type est connu (apprentissage de la signature).

}
function phagocyte(x : LongInt; y : LongInt) : LongInt; cdecl; external;

{
  Le leucocyte emet des anticorps autour de lui et sur sa case

}
function emet_anticorps() : LongInt; cdecl; external;

{
  Le leucocyte transmet un message.

}
function transmettre_message(message_arg1 : LongInt; message_arg2 : LongInt; message_arg3 : LongInt; message_arg4 : LongInt) : LongInt; cdecl; external;

{
  Le leucocyte recoit l'identifiant prochain message qu'on lui a envoye.

}
function recevoir_prochain_message() : LongInt; cdecl; external;

{
  Permet de connaitre le corps du message (le message reel en fait)

}
function corps_message(message_id : LongInt; argument_id : LongInt) : LongInt; cdecl; external;

implementation

begin
end.
